AlertPrimeUI = class(Turbine.UI.Window)
function AlertPrimeUI:Constructor(parent, x, y, width, height, borderSize, scale, borderColour, backgroundColour, fontColour, font, alignment, text, durationFont, showDuration, durationAlignment, decimalThreshold, outlineColour)
    Turbine.UI.Window.Constructor(self)
    self:SetParent(parent)
    self:SetPosition(x, y)
    self:SetSize((width + 2 * borderSize) * scale, (height + 2 * borderSize) * scale)
    self:SetMouseVisible(false)
    self:SetBackColor(borderColour)
    self:SetVisible(false)

    self.outlineColour = Turbine.UI.Color(0,0,0)
    if outlineColour and outlineColour.A > 0 then
        self.outlineColour = outlineColour
    end

    self.decimalThreshold = decimalThreshold

    self.innerbar = Turbine.UI.Label()
    self.innerbar:SetParent(self)
    self.innerbar:SetPosition(borderSize * scale, borderSize * scale)
    self.innerbar:SetSize(width, height)
    self.innerbar:SetMouseVisible(false)
    --self.innerbar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.innerbar:SetBackColor(backgroundColour)
    self.innerbar:SetForeColor(fontColour)
    self.innerbar:SetOutlineColor(self.outlineColour)
    self.innerbar:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.innerbar:SetFont(font)
    self.innerbar:SetTextAlignment(alignment)
    self.innerbar:SetText(text)

    --self.innerbar:SetStretchMode(1)
    self.innerbar:SetSize(width * scale, height * scale)

    self.durationLabel = Turbine.UI.Label()
    self.durationLabel:SetParent(self)
    self.durationLabel:SetPosition(borderSize * scale, borderSize * scale)
    self.durationLabel:SetSize(width, height)
    self.durationLabel:SetMouseVisible(false)
    --self.durationLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.durationLabel:SetForeColor(fontColour)
    self.durationLabel:SetFont(durationFont)
    self.durationLabel:SetTextAlignment(durationAlignment)
    self.durationLabel:SetText(text)
    self.durationLabel:SetVisible(showDuration)

    self.duration = 0


    self.ExecuteUpdate = function(delta)
        self.duration = self.duration - delta
        
        if self.duration < 1 then
            self:SetOpacity(self.duration + 0.3)
        end

        if self.duration > self.decimalThreshold then
            self.durationLabel:SetText(string.format("%i", self.duration))
        else
            self.durationLabel:SetText(string.format("%.2f", self.duration))
        end

        if self.duration <= 0 then
            self:SetVisible(false)
            if self.callback then RemoveCallback(Updater, "ExecuteUpdate", self.callback) end
            self.callback = nil
        end
    end

end

function AlertPrimeUI:SetAlert(time, text)
    self:SetVisible(true)
    self.innerbar:SetText(text)
    self:SetOpacity(1)
    self.duration = time
    if self.duration < self.decimalThreshold then
        self.durationLabel:SetText(string.format("%i", self.duration))
    else
        self.durationLabel:SetText(string.format("%.2f", self.duration))
    end

    if not(self.callback) then self.callback = AddCallback(Updater, "ExecuteUpdate", self.ExecuteUpdate) end
end